-- ƕz buAlignAndSpace.mcr Ver.1.1
-- ؘaG kasiwagi@ummb.jp
-- [hWŌڏd̐ƕzsȂBƒɎ̖ϔO킬ƂA
-- Eɂ낦ƂAcɕׂAƂŁB
-- CXg[Fbmp<max>\ui\MacroScriptsɂԂłBmcrꏏɁB
-- 
-- 1.1 Cӂ̃r[œ悤ɂȂ
-- 1.0 ŏ̃o[W

macroScript buAlignAndSpace
enabledIn:#("max") --pfb: 2003.12.12 added product switch
	category:"Bu"
	buttontext:"buAlignAndSpace"
	toolTip:"buAlignAndSpace" 
(
	fn checkXYZ  p = -- ̃`FbN
	(
		local x = abs p.x
		local y = abs p.y
		local z = abs p.z
		
		if x>y then
			if x>z then vAxis = 1 else vAxis = 3
		else
			if y>z then vAxis = 2 else vAxis = 3
		if 0.0 < p[vAxis] then return vAxis else return -vAxis
	)

	fn getViewXY = -- r[ł̎ԂB
	(
		local pH = (Inverse(getViewTM())).row1
		local pV = (Inverse(getViewTM())).row2
		return #(checkXYZ pH, checkXYZ pV)
	)

	fn getAlignPos obj axis mode = -- w莲̒ʒu擾
	(
		case mode of
		(
			1:( -- 
				if 0 < axis then
					return obj.min[axis]
				else
					return obj.max[-axis]
			)
			2:( -- 
				return obj.center[abs(axis)]
			)
			3:( -- pivot
				return obj.center[abs(axis)]
			)
			4:( -- E
				if 0 < axis then
					return obj.max[axis]
				else
					return obj.min[-axis]
			)
			5:( -- 
				if 0 < axis then
					return obj.max[axis]
				else
					return obj.min[-axis]
			)
			6:( -- 
				return obj.center[abs(axis)]
			)
			7:( -- pivot
				return obj.center[abs(axis)]
			)
			8:( -- 
				if 0 < axis then
					return obj.min[axis]
				else
					return obj.max[-axis]
			)
		)
	)

	fn buAlign mode =
	(
		if 2>selection.count do return()
		undo "buAandS" on
		(
			local viewXY = getViewXY()

			if 5 > mode then mIndex=1 else mIndex=2
			local alignPos = getAlignPos selection viewXY[mIndex] mode

			for i in selection do
			(
				if 3 == mode or 7 == mode then -- Pivot ␳
				(
					case abs(viewXY[mIndex]) of -- pos[]ł͑łȂ̂H
					(
						1: i.pos.x = alignPos
						2: i.pos.y = alignPos
						3: i.pos.z = alignPos
					)
				)
				else
				(
					local relPos = getAlignPos i viewXY[mIndex] mode
					case abs(viewXY[mIndex]) of -- pos[]ł͑łȂ̂H
					(
						1: i.pos.x = alignPos - relPos + i.pos.x
						2: i.pos.y = alignPos - relPos + i.pos.y
						3: i.pos.z = alignPos - relPos + i.pos.z
					)
				)
			)
		)
	)

	-- (1~3)Ɣr@Ԃ1:max 2:center 3:pivot 4:min
	fn getSpacingAxis axis mode =
	(
		case mode of
		(
			1:( -- ӏcz
				if 0 > axis[2] then
					return #(abs axis[2],4)
				else
					return #(abs axis[2],1)
			)
			2:( -- cz
				return #(abs axis[2],2)
			)
			3:( -- pivotcz
				return #(abs axis[2],3)
			)
			4:( -- ӏcz
				if 0 > axis[2] then
					return #(abs axis[2],1)
				else
					return #(abs axis[2],4)
			)
			5:( -- Ӊz
				if 0 < axis[1] then
					return #(abs axis[1],4)
				else
					return #(abs axis[1],1)
			)
			6:( -- z
				return #(abs axis[1],2)
			)
			7:( -- pivotz
				return #(abs axis[1],3)
			)
			8:( -- EӉz
				if 0 < axis[1] then
					return #(abs axis[1],1)
				else
					return #(abs axis[1],4)
			)
		)
	)

	-- qsortpr֐
	fn compMax obj1 obj2 axis: =
	(
		local l = obj1.max[axis] - obj2.max[axis]
		case of
		(
			(l < 0.): -1
			(l > 0.): 1
			default: 0
		)
	)
	fn compCenter obj1 obj2 axis: =
	(
		local l = obj1.center[axis] - obj2.center[axis]
		case of
		(
			(l < 0.): -1
			(l > 0.): 1
			default: 0
		)
	)
	fn compPivot obj1 obj2 axis: =
	(
		local l = obj1.pos[axis] - obj2.pos[axis]
		case of
		(
			(l < 0.): -1
			(l > 0.): 1
			default: 0
		)
	)
	fn compMin obj1 obj2 axis: =
	(
		local l = obj1.min[axis] - obj2.min[axis]
		case of
		(
			(l < 0.): -1
			(l > 0.): 1
			default: 0
		)
	)
		
	fn buSpace mode =
	(
		if 3>selection.count do return()
		undo "buAandS" on
		(
			local posMax,posMin,rel,sp

			local viewXY = getViewXY()
			local spAxis = getSpacingAxis viewXY mode

			local obj = for i in selection collect i
			case spAxis[2] of -- \[g
			(
				1: qsort obj compMax axis:spAxis[1]
				2: qsort obj compCenter axis:spAxis[1]
				3: qsort obj compPivot axis:spAxis[1]
				4: qsort obj compMin axis:spAxis[1]
			)

			case spAxis[2] of
			(
				1: (
					posMax = obj[obj.count].max[spAxis[1]]
					posMin = obj[1].max[spAxis[1]]
				)
				2: (
					posMax = obj[obj.count].center[spAxis[1]]
					posMin = obj[1].center[spAxis[1]]
				)
				3: (
					posMax = obj[obj.count].pos[spAxis[1]]
					posMin = obj[1].pos[spAxis[1]]
				)
				4: (
					posMax = obj[obj.count].min[spAxis[1]]
					posMin = obj[1].min[spAxis[1]]
				)
			)
			sp = (posMax-posMin)/(obj.count-1)
			for i=2 to (obj.count-1) do
			(
				case spAxis[2] of -- pivot̕␳
				(
					1: rel = obj[i].pos - obj[i].max[spAxis[1]]
					2: rel = obj[i].pos - obj[i].center[spAxis[1]]
					3: rel = [0,0,0]
					4: rel = obj[i].pos - obj[i].min[spAxis[1]]
				)
				case abs(spAxis[1]) of
				(
					1: obj[i].pos.x = posMin + sp * (i-1) + rel.x
					2: obj[i].pos.y = posMin + sp * (i-1) + rel.y
					3: obj[i].pos.z = posMin + sp * (i-1) + rel.z
				)
			)
		)
	)
	
	
	rollout buAandSRoll "buAlignAndSpace" width:148
	(
		button btnA1 "Un" pos:[  4, 4] width:32 height:24 images:#("buAandS.bmp", "buAandSM.bmp", 16, 1, 1, 1, 1)
		button btnA2 "Is" pos:[ 40, 4] width:32 height:24 images:#("buAandS.bmp", "buAandSM.bmp", 16, 2, 2, 2, 2)
		button btnA3 "S1" pos:[ 76, 4] width:32 height:24 images:#("buAandS.bmp", "buAandSM.bmp", 16, 3, 3, 3, 3)
		button btnA4 "S2" pos:[112, 4] width:32 height:24 images:#("buAandS.bmp", "buAandSM.bmp", 16, 4, 4, 4, 4)
		button btnA5 "Rf" pos:[  4,31] width:32 height:24 images:#("buAandS.bmp", "buAandSM.bmp", 16, 5, 5, 5, 5)
		button btnA6 "sp" pos:[ 40,31] width:32 height:24 images:#("buAandS.bmp", "buAandSM.bmp", 16, 6, 6, 6, 6)
		button btnA7 "RI" pos:[ 76,31] width:32 height:24 images:#("buAandS.bmp", "buAandSM.bmp", 16, 7, 7, 7, 7)
		button btnA8 "RO" pos:[112,31] width:32 height:24 images:#("buAandS.bmp", "buAandSM.bmp", 16, 8, 8, 8, 8)

		on btnA1 pressed do buAlign 1
		on btnA2 pressed do buAlign 2
		on btnA3 pressed do buAlign 3
		on btnA4 pressed do buAlign 4
		on btnA5 pressed do buAlign 5
		on btnA6 pressed do buAlign 6
		on btnA7 pressed do buAlign 7
		on btnA8 pressed do buAlign 8

		button btnS1 "Un" pos:[  4,61] width:32 height:24 images:#("buAandS.bmp", "buAandSM.bmp", 16, 9, 9, 9, 9)
		button btnS2 "Is" pos:[ 40,61] width:32 height:24 images:#("buAandS.bmp", "buAandSM.bmp", 16,10,10,10,10)
		button btnS3 "S1" pos:[ 76,61] width:32 height:24 images:#("buAandS.bmp", "buAandSM.bmp", 16,11,11,11,11)
		button btnS4 "S2" pos:[112,61] width:32 height:24 images:#("buAandS.bmp", "buAandSM.bmp", 16,12,12,12,12)
		button btnS5 "Rf" pos:[  4,88] width:32 height:24 images:#("buAandS.bmp", "buAandSM.bmp", 16,13,13,13,13)
 		button btnS6 "sp" pos:[ 40,88] width:32 height:24 images:#("buAandS.bmp", "buAandSM.bmp", 16,14,14,14,14)
		button btnS7 "RI" pos:[ 76,88] width:32 height:24 images:#("buAandS.bmp", "buAandSM.bmp", 16,15,15,15,15)
		button btnS8 "RO" pos:[112,88] width:32 height:24 images:#("buAandS.bmp", "buAandSM.bmp", 16,16,16,16,16)

		on btnS1 pressed do buSpace 1
		on btnS2 pressed do buSpace 2
		on btnS3 pressed do buSpace 3
		on btnS4 pressed do buSpace 4
		on btnS5 pressed do buSpace 5
		on btnS6 pressed do buSpace 6
		on btnS7 pressed do buSpace 7
		on btnS8 pressed do buSpace 8
	
	
	) -- rollout

	-- _CAO쐬
	global buAlignAndSpacePos = [200,100]
	on isChecked do buAandSRoll.open
	on execute do createDialog buAandSRoll pos:buAlignAndSpacePos
	on closeDialogs do
	(
		buAlignAndSpacePos = GetDialogPos buAandSRoll
		destroyDialog buAandSRoll
	)
)

